<!DOCTYPE html>
<html lang="en">
  <head>
    <title>TASK 20.100 Registration form</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <!-- TODO 0: Nhúng thư viện boostrap -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css"
    />
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
    <style>
      #inp-male {
        width: 20%;
      }

      #inp-subject {
        width: 100%;
      }
    </style>
  </head>
  <body>
    <div class="container jumbotron">
      <div class="row">
        <div class="col-md-12 text-center">
          <h4>Registration form</h4>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="row form-group">
            <div class="col-md-3">
              <label>First Name <span style="color: red">(*)</span></label>
            </div>
            <div class="col-md-9">
              <input id="inp-first-name" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Last Name <span style="color: red">(*)</span></label>
            </div>
            <div class="col-md-9">
              <input id="inp-last-name" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Birth Day <span style="color: red">(*)</span></label>
            </div>
            <div class="col-md-9">
              <input id="inp-birth-day" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Gender <span style="color: red">(*)</span></label>
            </div>
            <form class="col-md-9">
              <div class="row">
                <div class="col-md-6">
                  <div class="row form-group">
                    <input
                      type="radio"
                      class="col-4"
                      value="male"
                      name="gender"
                    />
                    <label for="" class="col-8">male</label>
                  </div>
                </div>
                <div class="col-md-6">
                  <div class="row form-group">
                    <input
                      type="radio"
                      class="col-4"
                      name="gender"
                      value="female"
                    />
                    <label for="" class="col-8">female</label>
                  </div>
                </div>
              </div>
            </form>
          </div>
        </div>
        <div class="col-md-6">
          <div class="row form-group">
            <div class="col-md-3">
              <label>Passport <span style="color: red">(*)</span></label>
            </div>
            <div class="col-md-9">
              <input id="inp-passport" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Email</label>
            </div>
            <div class="col-md-9">
              <input id="inp-email" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Country <span style="color: red">(*)</span></label>
            </div>
            <div class="col-md-9">
              <input id="inp-country" type="text" class="form-control" />
            </div>
          </div>
          <div class="row form-group">
            <div class="col-md-3">
              <label>Region</label>
            </div>
            <div class="col-md-9">
              <input id="inp-region" type="text" class="form-control" />
            </div>
          </div>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-md-2">
          <label>Subject:</label>
        </div>
        <div class="col-md-10">
          <textarea
            id="inp-subject"
            type="text"
            class="form-control"
          ></textarea>
        </div>
      </div>
      <br />
      <div class="row">
        <div class="col-md-12 text-right">
          <button type="button" class="btn btn-success col-2" id="btn-submit">
            Submit
          </button>
        </div>
      </div>
    </div>
  </body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gFirstNameInput = $("#inp-first-name");
    var gLastNameInput = $("#inp-last-name");
    var gBirthDayInput = $("#inp-birth-day");
    var gGenderInput = $("input[name='gender']:checked");
    var gPassportInput = $("#inp-passport");
    var gCountryInput = $("#inp-country");
    var gEmailInput = $("#inp-email");
    var gRegionInput = $("#inp-region");
    var gSubjectInput = $("#inp-subject");

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      $("#btn-submit").on("click", function (event) {
        event.preventDefault();
        onBtnSubmitClick();
      });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnSubmitClick() {
      var vObjUser = {
        firstname: "",
        lastname: "",
        birthday: "",
        gender: "",
        passport: "",
        email: "",
        country: "",
        region: "",
        subject: "",
      };
      readData(vObjUser);
      var vCheck = valiDate(vObjUser);
      if (vCheck) {
        displayConsole(vObjUser);
      }
    }

    function readData(paramUser) {
      paramUser.firstname = gFirstNameInput.val().trim();
      paramUser.lastname = gLastNameInput.val().trim();
      paramUser.birthday = gBirthDayInput.val().trim();
      paramUser.gender = $("input[name='gender']:checked").val();
      paramUser.passport = gPassportInput.val().trim();
      paramUser.email = gEmailInput.val().trim();
      paramUser.country = gCountryInput.val().trim();
      paramUser.region = gRegionInput.val().trim();
      paramUser.subject = gSubjectInput.val().trim();
    }

    function valiDate(paramUser) {
      if (paramUser.firstname == "") {
        alert("Firstname không được để trống!");
        return false;
      }
      if (paramUser.lastname == "") {
        alert("Lastname không được để trống!");
        return false;
      }
      if (paramUser.birthday == "") {
        alert("Birthday không được để trống!");
        return false;
      }
      if (paramUser.gender == null) {
        alert("Gender không được để trống!");
        return false;
      }
      if (paramUser.passport == "") {
        alert("Passport không được để trống!");
        return false;
      }
      if (isEmail(paramUser.email) == false) {
        return false;
      }
      if (paramUser.country == "") {
        alert("Country không được để trống!");
        return false;
      }
      if (paramUser.region == "") {
        alert("Region không được để trống!");
        return false;
      }
      if (paramUser.subject == "") {
        alert("Subject không được để trống!");
        return false;
      }
      return true;
    }

    //hàm kiểm tra email
    function isEmail(paramEmail) {
      if (paramEmail < 3) {
        alert("Nhập email...");
        return false;
      }
      if (paramEmail.indexOf("@") === -1) {
        alert("Email phải có ký tự @");
        return false;
      }
      if (paramEmail.startsWith("@") === true) {
        alert("Email không bắt đầu bằng @");
        return false;
      }
      if (paramEmail.endsWith("@") === true) {
        alert("Email kết thúc bằng @");
        return false;
      }
      return true;
    }

    function displayConsole(paramUser) {
      console.log(paramUser);
    }
  </script>
</html>
